From 511c22043846c7453cea8b00bf911705417609eb Mon Sep 17 00:00:00 2001
From: Alvaro Herrera <alvherre@alvh.no-ip.org>
Date: Mon, 27 Apr 2020 19:35:15 -0400
Subject: [PATCH] Don't freeze on checkpoints

---
 src/backend/postmaster/checkpointer.c | 7 +++++++
 1 file changed, 7 insertions(+)

diff --git a/src/backend/postmaster/checkpointer.c b/src/backend/postmaster/checkpointer.c
index e354a78725..5cf5e9fe08 100644
--- a/src/backend/postmaster/checkpointer.c
+++ b/src/backend/postmaster/checkpointer.c
@@ -494,6 +494,13 @@ CheckpointerMain(void)
 		 */
 		pgstat_send_bgwriter();
 
+		/*
+		 * Don't sleep if our latch was set for reasons other than a
+		 * checkpoint request.
+		 */
+		if (!do_checkpoint)
+			continue;
+
 		/*
 		 * Sleep until we are signaled or it's time for another checkpoint or
 		 * xlog file switch.
-- 
2.20.1

